CF1096:D. Easy Problem(DP)

Vasya is preparing a contest, and now he has written a statement for an easy problem. The statement is a string of length n

consisting of lowercase Latin latters. Vasya thinks that the statement can be considered hard if it contains a subsequence hard; otherwise the statement is easy. For example, hard, hzazrzd, haaaaard can be considered hard statements, while har, hart and drah are easy statements.

Vasya doesn't want the statement to be hard. He may remove some characters from the statement in order to make it easy. But, of course, some parts of the statement can be crucial to understanding. Initially the ambiguity of the statement is 0

, and removing i-th character increases the ambiguity by ai (the index of each character is considered as it was in the original statement, so, for example, if you delete character r from hard, and then character d, the index of d is still 4

even though you delete it from the string had).

Vasya wants to calculate the minimum ambiguity of the statement, if he removes some characters (possibly zero) so that the statement is easy. Help him to do it!

Recall that subsequence is a sequence that can be derived from another sequence by deleting some elements without changing the order of the remaining elements.

Input

The first line contains one integer n

(1n105

) — the length of the statement.

The second line contains one string s

of length n

, consisting of lowercase Latin letters — the statement written by Vasya.

The third line contains n

integers a1,a2,,an (1ai998244353

).

Output

Print minimum possible ambiguity of the statement after Vasya deletes some (possibly zero) characters so the resulting statement is easy.

Examples
Input
Copy
6
hhardh
3 2 9 11 7 1
Output
Copy
5
Input
Copy
8
hhzarwde
3 2 6 9 4 8 7 1
Output
Copy
4
Input
Copy
6
hhaarr
1 2 3 4 5 6
Output
Copy
0
Note

In the first example, first two characters are removed so the result is ardh.

In the second example, 5

-th character is removed so the result is hhzawde.

In the third example there's no need to remove anything.

题意:给定一个字符串,每个字符自带权值,让你删去一些,使得不存在子序列“hard”,问最下的权值是多少。

思路:因为有顺序问题,所以我们记录维护到当前最长的前缀的代价。1对应h,2对应ha,3对应har,4对应hard,然后就不难写出方程了。

(复杂度O(5N),比赛时写了个2进制,复杂度O(16N);傻了

#include<bits/stdc++.h>
#define rep(i,a,b) for(int i=a;i<=b;i++)
using namespace std;
#define ll long long
const int maxn=200010;
int a[maxn];ll dp[maxn][5],ans; char c[maxn]; int Laxt[maxn];
int id(char s){
    if(s=='h') return 1;
    if(s=='a') return 2;
    if(s=='r') return 3;
    if(s=='d') return 4;
    return -1;
}
void ADD(ll &x,ll y){
    if(y==-1) return ;
    if(x==-1) x=y;
    else x=min(x,y);
}
int main()
{
    int N;
    scanf("%d%s",&N,c+1); memset(dp,-1,sizeof(dp));
    rep(i,1,N) scanf("%d",&a[i]);
    dp[0][0]=0;
    rep(i,1,N){
        int p=id(c[i]);
        if(p==-1) {
            rep(j,0,4) dp[i][j]=dp[i-1][j];
            continue;
        }
        if(dp[i-1][p-1]!=-1) ADD(dp[i][p-1],dp[i-1][p-1]+a[i]);
        ADD(dp[i][p],dp[i-1][p-1]);
        rep(j,0,4){
            if(j==p-1) continue;
            ADD(dp[i][j],dp[i-1][j]);
        }
    }
    ans=1LL<<60; rep(i,0,3) if(dp[N][i]!=-1) ans=min(ans,dp[N][i]);
    printf("%lld
",ans);
    return 0;
}
原文地址:https://www.cnblogs.com/hua-dong/p/10194448.html